﻿// Кэш системной информации
//  

#Область СлужебныйПрограммныйИнтерфейс

// Возвращает параметры соединения с информационной базой
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Стурктура - вида
// 		Файловая
// 		СерверПриложения
// 		ИнформационнаяБаза
// 		Каталог
//
Функция ИнформационнаяБазаСоединениеПараметры() Экспорт
	
	Результат			= Новый Структура("Файловая, СерверПриложения, ИнформационнаяБаза, Каталог");
	ЭлементСоставЧасти	= 2;
	
	Для Каждого Элемент Из исперп_Строка.ВМассив(СтрокаСоединенияИнформационнойБазы(), ";") Цикл
		Состав	= исперп_Строка.ВМассив(Элемент, "=");
		Если Состав.Количество() = ЭлементСоставЧасти Тогда
			Имя			= ВРег(СокрЛ(Состав[0]));
			Значение	= исперп_Строка.ОбрамлениеУдалить(СокрЛП(Состав[1]), """");
			Если Имя = "FILE" Тогда
				Результат.Каталог	= Значение;
				Результат.Файловая	= Истина;
			ИначеЕсли Имя = "SRVR" Тогда
				Результат.СерверПриложения	= Значение;
				Результат.Файловая			= Ложь;
			Иначе
				// Такая конструкция для того, чтобы код был по канонам
				Если Имя = "REF" Тогда
					Результат.ИнформационнаяБаза	= Значение;
					Результат.Файловая				= Ложь;
				КонецЕсли;
			КонецЕсли;
		КонецЕсли;
	КонецЦикла;
	
	Возврат Новый ФиксированнаяСтруктура(Результат);

КонецФункции // ИнформационнаяБазаСоединениеПараметры 

// Возвращает версия приложения. Например 8.2.19.103
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 
Функция ПриложениеВерсия() Экспорт
	
	Возврат ИнформацияСистемная().ВерсияПриложения;
	
КонецФункции // ПриложениеВерсия 

// Возвращает идентификатор клиента
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	УникальныйИдентификатор
// 
Функция КлиентИдентификатор() Экспорт
	
	Возврат ИнформацияСистемная().ИдентификаторКлиента;
	
КонецФункции // КлиентИдентификатор 

// Возвращает размер оперативной памяти
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Число
// 
Функция ПамятьКоличество() Экспорт
	
	Возврат ИнформацияСистемная().ОперативнаяПамять;
	
КонецФункции // ПамятьКоличество 

// Возвращает тип процессора
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Строка
// 
Функция Процессор() Экспорт
	
	Возврат ИнформацияСистемная().Процессор;
	
КонецФункции // Процессор

// Возвращает тип платформы (windows/linux/...)
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	ТипПлатформы|Неопредеелно
// 
Функция ПлатформаТип() Экспорт
	
	Возврат ИнформацияСистемная().ТипПлатформы;
	
КонецФункции // ПлатформаТип 

// Истина, если платформа выполнения Windows x86
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаWindows32Это() Экспорт
	
	Возврат ПлатформаТип() = ТипПлатформы.Windows_x86;
	
КонецФункции // ПлатформаWindows32Это 

// Истина, если платформа выполнения Windows x86 64
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаWindows64Это() Экспорт
	
	Возврат ПлатформаТип() = ТипПлатформы.Windows_x86_64;
	
КонецФункции // ПлатформаWindows64Это 

// Истина, если платформа выполнения Mac x86
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаMac32Это() Экспорт
	
	Возврат ПлатформаТип() = ТипПлатформы.MacOS_x86;
	
КонецФункции // ПлатформаMac32Это 

// Истина, если платформа выполнения Mac x86 64
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаMac64Это() Экспорт
	
	Возврат ПлатформаТип() = ТипПлатформы.MacOS_x86_64;
	
КонецФункции // ПлатформаMac64Это 

// Истина, если платформа выполнения Linux x86
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаLinux32Это() Экспорт
	
	Возврат ПлатформаТип() = ТипПлатформы.Linux_x86;
	
КонецФункции // ПлатформаLinux32Это 

// Истина, если платформа выполнения Linux x86 64
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаLinux64Это() Экспорт
	
	Возврат ПлатформаТип() = ТипПлатформы.Linux_x86_64;
	
КонецФункции // ПлатформаLinux64Это 

// Истина, если платформа выполнения Windows
// 
// Параметры:  
// 
// Возвращаемое значение: 
//  Булево
// 
Функция ПлатформаWindowsЭто() Экспорт
	
	Возврат ПлатформаWindows32Это() ИЛИ ПлатформаWindows64Это();
	
КонецФункции // ПлатформаWindowsЭто 

// Истина, если платформа выполнения MacOS
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаMacЭто() Экспорт
	
	Возврат ПлатформаMac32Это() ИЛИ ПлатформаMac64Это();
	
КонецФункции // ПлатформаMacЭто 

// Истина, если платформа выполнения Linux
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Булево
// 
Функция ПлатформаLinuxЭто() Экспорт
	
	Возврат ПлатформаLinux32Это() ИЛИ ПлатформаLinux64Это();
	
КонецФункции // ПлатформаLinuxЭто 

// Возвращает символ разделитель каталогов
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	Строка
// 
Функция КаталогиСимволРазделитель() Экспорт
	
	Возврат ?(ПлатформаWindowsЭто(), "\", "/");
	
КонецФункции // КаталогиСимволРазделитель 

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

// Возвращает объект системной информации
// 
// Параметры:  
// 
// Возвращаемое значение: 
// 	системнаяИнформация
// 
Функция ИнформацияСистемная()
	
	Возврат Новый СистемнаяИнформация;
	
КонецФункции // ИнформацияСистемная 

#КонецОбласти
